# No debuginfo:
%define debug_package %{nil}

# If you want to debug, uncomment the next line and remove
# the duplicate percent sign (due to macro expansion)
#%%dump

%define name rkhunter
%define ver 1.3.4
%define rel 15test.jinr

%define epoch 0

# Don't change this define or also:
# 1. use installer.sh with like --layout /usr or --layout custom /some/dir
# 2. rewrite the files section below.
%define _prefix /usr

# We can't let RPM do the dependencies automatic because it'll then pick up
# a correct but undesirable perl dependency, which rkhunter does not require
# in order to function properly.
AutoReqProv: no

Name: %{name}
Summary: %{name} scans for rootkits, backdoors and local exploits
Version: %{ver}
Release: %{rel}
Epoch: %{epoch}
License: GPL
Group: Applications/System
Source0: http://downloads.sourceforge.net/rkhunter/%{name}-%{version}.tar.gz
Source1: http://downloads.sourceforge.net/rkhunter/rkhunter-1.3.4.tar.gz.asc
Source10:        http://www.security-projects.com/unhide20080519.tgz
#Source20:        http://www.xs4all.nl/~dvgevers/skdet/skdet-1.0.tar.bz2
Requires: filesystem, bash, grep, findutils, net-tools, coreutils, e2fsprogs, modutils, procps, binutils, wget, perl
Provides: %{name}
URL: http://rkhunter.sourceforge.net/
BuildRoot: %{_tmppath}/%{name}-%{version}
# no longer "noarch" since we have static i386 binaries in here
ExclusiveArch:	i386


#Patch1:         rkhunter-1.3.0-ldgames.patch  # done differently in 1.3.2
#Patch2:         rkhunter-1.3.0-rpmmd5.patch   # has something about RPM handling
#Patch3:         rkhunter-1.2.9-gpghomedir.patch
#Patch4:         rkhunter-1.2.9-syslog.patch   # implemented in 1.3.2
#Patch5:         rkhunter-1.2.9-ssh1.patch     # implemented in 1.3.2
Patch6:         rkhunter-1.3.0-installprefix.patch
Patch7:         rkhunter-1.3.2-mailwarn-quietcron.patch
#Patch8:         rkhunter-1.3.0-umask.patch    # explicit chmod in 1.3.2
#Patch9:         rkhunter-1.3.0-sshdversion.patch # fixed in 1.3.2
#Patch10:        rkhunter-1.3.0-tr-quote.patch    # apparently fixed in 1.3.2
Patch11:        rkhunter-1.3.0-phalanx2-sig.patch
#Patch12:        rkhunter-1.3.4-rpm-biarch.patch # went into 1.3.4
Patch13:        rkhunter-1.3.4-whitelist-hash.patch
#Patch14:        rkhunter-1.3.2-ldd-noaddress.patch # went into 1.3.4
Patch15:        rkhunter-1.3.4-xinetd-rpm.patch
Patch16:        rkhunter-1.3.4-nodata_use_rpm.patch
Patch17:        rkhunter-1.3.4-sshroot-accept-disable.patch
Patch18:        rkhunter-1.3.4-network-outgoing.patch
Patch19:        rkhunter-1.3.4-osinfo-autoupdate.patch
# from Fedora/EPEL
#Patch20:        rkhunter-1.3.2-debugtmp.patch   # similar in 1.3.4

# our configuration
Patch100:        rkhunter-cern-config.patch

# JINR config
Patch200:        rkhunter-jinr-config.patch

# patches to "unhide"; sent upstream 2009-01-19
Patch1000: unhide-linux26-getaffinityfix.patch
Patch1001: unhide-linux26-maxpid.patch
Patch1002: unhide-linux26-noawk.patch
Patch1003: unhide-linux26-kill_nops.patch
Patch1004: unhide-linux26-doublecheck.patch

%description
Rootkit scanner is [a] scanning tool to ensure you for about 99.9%% you're
clean of nasty tools. This tool scans for rootkits, backdoors and local
exploits by running tests like:
	- MD5 hash compare
	- Look for default files used by rootkits
	- Wrong file permissions for binaries
	- Look for suspected strings in LKM and KLD modules
	- Look for hidden files
	- Optional scan within plaintext and binary files
	- Software version checks
	- Application tests

Rootkit Hunter is released as a GPL licensed project and free for
everyone to use.

  ********
This version has been customized/patched for JINR, and includes a
(patched) copy of "unhide" by yjesus AT security-projects.com


%prep
%setup -q -n %name-%version
#CVS
##%setup -q -n %name


# GONE %patch2 -p1 -b .md5
# GONE %patch3 -p1 -b .gpg
# GONE %patch4 -p1 -b .log
# GONE %patch5 -p1 -b .ssh1
# see whether we can do without %patch6 -p1 -b .usr
%patch7 -p1
# GONE %patch8 -p1 -b .umask
# GONE %patch9 -p1 -b .sshd
# GONE %patch10 -p1 -b .tr
%patch11 -p1
# GONE %patch12 -p1 -b .bi
%patch13 -p1
# GONE %patch14 -p1 -b .ldd
%patch15 -p0 
%patch16 -p0
%patch17 -p0
%patch18 -p0
%patch19 -p0
# GONE %patch20 -p1 -b .tmp

sed -i -e 's;^PROGRAM_version=.*;PROGRAM_version=%{version}-%{release};' files/rkhunter
# prefer the RPM install under /usr
sed -i -e 's;PREFIX="\${RPM_BUILD_ROOT}/usr/local";PREFIX="\${RPM_BUILD_ROOT}/usr";' installer.sh


%setup -n %name-%version -D -T -a 10
cd unhide-*
%patch1000
%patch1001
%patch1002
%patch1003
%patch1004

%build
# allow to detect "hidden" processes
pushd unhide-*

gcc  -m32 -static -O2 -o unhide unhide-linux26.c
gcc  -m32 -static -O2 -o unhide-tcp unhide-tcp.c

mv unhide unhide-tcp ../
mkdir -p ../man/
mv man/*8 ../man/
popd

# skdet - explicit detector for adore/suckit?  No. this is just a
# bruteforce PID lister and will run into temp process
# issues. "unhide" does the same job.


%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}/usr

# this actually modifies the config file..
sh ./installer.sh --layout RPM --install

pushd ${RPM_BUILD_ROOT}/%{_sysconfdir}
# create a CERNified configuraton just for the cron job
cp rkhunter.conf rkhunter.conf.cron
%{__patch} --no-backup-if-mismatch -p2 <%PATCH100
# JINR tuning
%{__patch} --no-backup-if-mismatch -p0 <%PATCH200
popd

install -D /dev/null ${RPM_BUILD_ROOT}/var/log/rkhunter.log

# make a cron.daily file to mail us the reports
%{__mkdir} -p "${RPM_BUILD_ROOT}/%{_sysconfdir}/cron.daily"
%{__cat} > "${RPM_BUILD_ROOT}/%{_sysconfdir}/cron.daily/zz_rkhunter" <<EOF
#!/bin/sh
%{_bindir}/rkhunter --cronjob --quiet --configfile %{_sysconfdir}/rkhunter.conf.cron
EOF
%{__chmod} a+rwx,g-w,o-rwx ${RPM_BUILD_ROOT}%{_sysconfdir}/cron.daily/zz_rkhunter

# install the "unhide" utilities
mkdir -p ${RPM_BUILD_ROOT}/usr/sbin
install -m 755  unhide ${RPM_BUILD_ROOT}/usr/sbin
install -m 755  unhide-tcp ${RPM_BUILD_ROOT}/usr/sbin
mkdir -p ${RPM_BUILD_ROOT}/%{_mandir}/man8/
install -m 644 man/unhide* ${RPM_BUILD_ROOT}/%{_mandir}/man8/

%clean
if [ "$RPM_BUILD_ROOT" = "/" ]; then
	echo Invalid Build root \'"$RPM_BUILD_ROOT"\'
	exit 1
else
	rm -rf $RPM_BUILD_ROOT
fi


%post
# most of the information will later come from RPM, but
# the files need to be listed in the "database"
if [ ! -e %{_var}/lib/%{name}/db/rkhunter.dat ]; then
  echo " creating initial rkhunter files property database"
  %{_prefix}/bin/%{name} --propupd --quiet
fi
#
# should we restrict somehow the "mail sending" to CERN machines? or even the "cronjob"?
# unclear, for now we get some more data on FPs..
#--dom=""
#--if [ -x /usr/bin/guess_domain.sh ]; then
#--   dom=`/usr/bin/guess_domain.sh`
#--elif [ -x /bin/dnsdomainname ]; then
#--   dom=`/bin/dnsdomainname 2>/dev/null`
#--fi
#--if [ "$dom" = "cern.ch" -o "$dom" = "tn.cern.ch" ]; then
#--  echo "rkhunter: running on a CERN machine.."
#--  # do something smart here.
#--else
#--  echo "rkhunter: NOT running on a CERN machine.. disabling cronjob."
#--  rm -f %{_sysconfdir}/cron.daily/zz_rkhunter 2>/dev/null || :
#--fi


##%define docdir %{_prefix}/share/doc/%{name}-*
%files
%defattr(-,root,root)
%attr(640,root,root) %config(noreplace) %verify(not mtime) %{_sysconfdir}/%{name}.conf
%attr(640,root,root) %config(noreplace) %verify(not mtime) %{_sysconfdir}/%{name}.conf.cron
%attr(750,root,root) %{_prefix}/bin/%{name}
%attr(750,root,root) %dir %{_var}/lib/%{name}
%attr(750,root,root) %dir %{_var}/lib/%{name}/db
%attr(640,root,root) %verify(not mtime) %{_var}/lib/%{name}/db/*.dat
%attr(750,root,root) %dir %{_var}/lib/%{name}/tmp
%attr(750,root,root) %dir %{_libdir}/%{name}/scripts
%attr(750,root,root) %{_libdir}/%{name}/scripts/*.pl
%attr(750,root,root) %{_libdir}/%{name}/scripts/*.sh
%attr(644,root,root) %{_prefix}/share/man/man8/%{name}.8*
%attr(750,root,root) %{docdir}
%attr(750,root,root) %dir %{_var}/lib/%{name}/db/i18n
%attr(640,root,root) %{_var}/lib/%{name}/db/i18n/*
%attr(755,root,root) /usr/sbin/unhide
%attr(755,root,root) /usr/sbin/unhide-tcp
%attr(644,root,root) %{_prefix}/share/man/man8/unhide*.8*
%attr(750,root,root) %config(missingok) %{_sysconfdir}/cron.daily/zz_rkhunter
%ghost %attr(0400,root,root) %{_var}/log/rkhunter.log


%changelog
* Thu Mar 19 2009 Jan Iven <jan.iven@cern.ch> - 1.3.4-5test.cern
- handle osinfo changes automatically, instead of carping
- unhide: multithreaded zombies don't show up in "ps axH" (but do in "ps ax", so are not hidden)
- network: only warn for connections *to* evil ports, not *from* them.

* Mon Mar  9 2009 Jan Iven <jan.iven@cern.ch> - 1.3.4-4test.cern
- fix another xinetd whitelisting bug - accept "bad timestamp but otherwise OK"

* Thu Jan 29 2009 Jan Iven <jan.iven@cern.ch> - 1.3.4-3test.cern
- fix xinetd whitelisting bug; still needs "properties" test to be run before
- add "uname" and rkhunter version to warning mail

* Mon Jan 19 2009 Jan Iven <jan.iven@cern.ch> - 1.3.4-2test.cern
- updated/patched "unhide"
- xinetd: trust RPM-added services
- missing "default" hashes - fall back to RPM
- accept stricter SSH-for-root configs without warning.
- rename cron job to "zz_" to give prelink a chance to run
- keep default config and use CERN-specific only for cronjob. and only at CERN.

* Mon Jan  5 2009 Jan Iven <jan.iven@cern.ch> - 1.3.4-1.cern
- go to 1.3.4

* Tue Dec 16 2008 Jan Iven <jan.iven@cern.ch> - 1.3.2-2.cern
- new patches for hash whitelisting, bi-arch
- enable syslog reporting, fix "mail" reporting
- disable suspscan (too many FP)

* Tue Dec  9 2008 Jan Iven <jan.iven@cern.ch> - 1.3.2-1.cern
- CERN patches: go to "real" 1.3.2
 
* Wed Oct 15 2008 Jan Iven <jan.iven@cern.ch>
- port CERN patches to post-1.3.2-CVS
- add "unhide" to RPM
- add more phalanx signatures

* Wed Jan 10 2007 Jan Iven <jan.iven@cern.ch> - 1.2.9-cvs20070108.cern
- port CERN patches to pre-1.3.0. again.
- added rpm/deb checksums

* Wed Dec 13 2006 Jan Iven <jan.iven@cern.ch> - 1.2.9-cvs20061212.cern
- port CERN patches to pre-1.3.0

* Tue Dec 5 2006 Jan Iven <jan.iven@cern.ch> - 1.2.9-2.cern
- "allow SSH1" parameter
- CERNified configuration: mail to root, ssh
 
* Mon Nov 27 2006 unSpawn - pre-1.3.0
- Sync spec with fixes, installer and CVS

* Wed Nov 23 2006 Jan Iven - 1.2.9-1.cern
- update to 1.2.9
- add support for RPM MD5, LD_* checks
- add hashupd

* Sun Nov 12 2006 unSpawn - 1.2.9
- Re-spec, new installer

* Fri Sep 29 2006 unSpawn - 1.2.9
- Updated for release 1.2.9

* Tue Aug 10 2004 Michael Boelen - 1.1.5
- Added update script
- Extended description

* Sun Aug 08 2004 Greg Houlette - 1.1.5
- Changed the install procedure eliminating the specification of
  destination filenames (only needed if you are renaming during install)
- Changed the permissions for documentation files (root only overkill)
- Added the installation of the rkhunter Man Page
- Added the installation of the programs_{bad, good}.dat database files
- Added the installation of the LICENSE documentation file
- Added the chmod for root only to the /var/rkhunter/db directory

* Sun May 23 2004 Craig Orsinger (cjo) <cjorsinger@earthlink.net>
- version 1.1.0-1.cjo
- changed installation in accordance with new rootkit installation
  procedure
- changed installation root to conform to LSB. Use standard macros.
- added recursive remove of old build root as prep for install phase

* Wed Apr 28 2004 Doncho N. Gunchev - 1.0.9-0.mr700
- dropped Requires: perl - rkhunter works without it 
- dropped the bash alignpatch (check the source or contact me)
- various file mode fixes (.../tmp/, *.db)
- optimized the %%files section - any new files in the
  current dirs will be fine - just %%{__install} them.

* Mon Apr 26 2004 Michael Boelen - 1.0.8-0
- Fixed missing md5blacklist.dat

* Mon Apr 19 2004 Doncho N. Gunchev - 1.0.6-1.mr700
- added missing /usr/local/rkhunter/db/md5blacklist.dat
- patched to align results in --cronjob, I think rpm based
  distros have symlink /bin/sh -> /bin/bash
- added --with/--without alignpatch for conditional builds
  (in case previous patch breaks something)

* Sat Apr 03 2004 Michael Boelen / Joe Klemmer - 1.0.6-0
- Update to 1.0.6

* Mon Mar 29 2004 Doncho N. Gunchev - 1.0.0-0
- initial .spec file

